Subject: Bootloader can't detect separate disk

From: Divya <[email-masked]>
Date: Tue, 07 May 2024 02:04:44 +0000

Hello,

Here is my `bootloader` section of `config.scm`:

```
(bootloader (bootloader-configuration (bootloader grub-bootloader) (targets (list "/dev/sda")) 	 (menu-entries (list 			 (menu-entry 			 (label "Arch Linux") 			 (device (uuid "886fb01f-323f-40ab-9434-9f00feb96446" 'ext4)) 			 (linux "/boot/vmlinuz-linux-rt") 			 (linux-arguments '("root=UUID=886fb01f-323f-40ab-9434-9f00feb96446 rw quiet")) 			 (initrd "/boot/initramfs-linux-rt.img")))) 	 (default-entry 0) (keyboard-layout keyboard-layout)))
```

I am trying to dual boot Guix with Arch, the former resides in `/dev/sda8` and the latter at `/dev/sdb1`. But the aforementioned configuration doesn't load Arch's kernel resulting in a 'kernel not found error' on the GRUB screen.

I have tried to do some troubleshooting by changing the parameters, but nothing seems to be working. And importantly, when I checked at the GRUB cli by doing `ls`, I see `/dev/sdb1` to be `(hd1,msdos1)` but with `ls` it shows that no file system is detected on it, when it has the `ext4` filesystem that I can access by mounting it.

What could be causing this? I checked `/boot/grub/grub.cfg` and it is trying to search the appropriate disk using UUID but because of the filesystem error, it can't access it and thus the kernel doesn't boot.

I'd like some help on this, also `os-prober` correctly identifies the Arch distro. Can I use it with my `config.scm`? Probably not? Is it possible to integrate it? I have some familiarity with bootloaders, I'd like to see if I can contribute here.

Regards,

Divya